# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Member Functions | Private Attributes
dirac::CompCompressor Class Reference

Compress a picture component. More...

`#include <comp_compress.h>`

List of all members.

## Public Member Functions
| CompCompressor (EncoderParams &encp, const PictureParams &fp)
| Constructor.
ComponentByteIO * | Compress (CoeffArray &coeff_data, SubbandList &bands, CompSort csort, const OneDArray< unsigned int > &estimated_bits)
| Compress a picture component.

## Private Member Functions
| CompCompressor (const CompCompressor &cpy)
| Copy constructor is private and body-less. This class should not be copied.
CompCompressor & | operator= (const CompCompressor &rhs)
| Assignment = is private and body-less. This class should not be assigned.
void | SetToVal (CoeffArray &coeff_data, const Subband &node, ValueType val)
| Set a subband to a constant value.

## Private Attributes
EncoderParams & | m_encparams
const PictureParams & | m_pparams
const PictureSort & | m_psort
const ChromaFormat & | m_cformat
float | m_lambda

## Detailed Description

This class compresses one of the three components (Y, U, or V) of a picture according to a given set or parameters. CompCompressor is used by PictureCompressor.

## Constructor & Destructor Documentation

dirac::CompCompressor::CompCompressor | ( | EncoderParams & | encp,
|  | const PictureParams & | fp
| ) |  |

Create and initialize a component compressor with the given characteristics.

Parameters:

  encp | encoding parameters
  fp | picture parameters

dirac::CompCompressor::CompCompressor | ( | const CompCompressor & | cpy | ) |
| private

## Member Function Documentation

ComponentByteIO* dirac::CompCompressor::Compress | ( | CoeffArray & | coeff_data,
|  | SubbandList & | bands,
|  | CompSort | csort,
|  | const OneDArray< unsigned int > & | estimated_bits
| ) |  |

Compress a PicArray containing a picture component (Y, U, or V).

Parameters:

  coeff_data | the component data to be compressed
  bands | Subbands list
  csort | Chroma format
  estimated_bits | the list of estimated number of bits in each subband

Returns:
  Picture-component in Dirac-bytestream format

CompCompressor& dirac::CompCompressor::operator= | ( | const CompCompressor & | rhs | ) |
| private

void dirac::CompCompressor::SetToVal | ( | CoeffArray & | coeff_data,
|  | const Subband & | node,
|  | ValueType | val
| ) |  |
| private

## Member Data Documentation

const ChromaFormat& dirac::CompCompressor::m_cformat
| private

EncoderParams& dirac::CompCompressor::m_encparams
| private

float dirac::CompCompressor::m_lambda
| private

const PictureParams& dirac::CompCompressor::m_pparams
| private

const PictureSort& dirac::CompCompressor::m_psort
| private

The documentation for this class was generated from the following file:

- comp_compress.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.